#include <jni.h>
#include <stdio.h>
#include "test.h"

#define GET_METHOD(What, What1) jmethodID meth##What = (*env)->GetStaticMethodID(env, clazz, "m1","(Ljava/lang/Object;" #What1 "Ljava/lang/Object;)V");

#define CHECK_METHOD(What, What1) if (!meth##What) { printf ("could not get method with " #What1 "\n"); return; }

#define CALL_METHODA(What) (*env)->CallStaticVoidMethodA(env, clazz, meth##What, args);

#define CALL_METHODV(What) (*env)->CallStaticVoidMethod(env, clazz, meth##What, o, 1, o);

void JNICALL Java_test_invokeNative(JNIEnv *env, jclass clazz, jobject o)
{
    jvalue args[3];
    GET_METHOD(D, D)
    GET_METHOD(F, F)
    GET_METHOD(J, J)
    GET_METHOD(I, I)
    GET_METHOD(S, S)
    GET_METHOD(B, B)
    GET_METHOD(C, C)
    GET_METHOD(Z, Z)
    GET_METHOD(L, Ljava/lang/Object;)

    CHECK_METHOD(D, D)
    CHECK_METHOD(F, F)
    CHECK_METHOD(J, J)
    CHECK_METHOD(I, I)
    CHECK_METHOD(S, S)
    CHECK_METHOD(B, B)
    CHECK_METHOD(C, C)
    CHECK_METHOD(Z, Z)
    CHECK_METHOD(L, Ljava/lang/Object;)

    printf("\n\nwith CallStaticVoidMethodA:\n\n");

    args[0].l = o;
    args[1].i = 1;
    args[2].l = o;
    
    CALL_METHODA(D)
    CALL_METHODA(F)
    CALL_METHODA(J)
    CALL_METHODA(I)
    CALL_METHODA(S)
    CALL_METHODA(B)
    CALL_METHODA(C)
    CALL_METHODA(Z)
    CALL_METHODA(L)

    printf("\n\nwith CallStaticVoidMethod:\n\n");

    CALL_METHODV(D)
    CALL_METHODV(F)
    CALL_METHODV(J)
    CALL_METHODV(I)
    CALL_METHODV(S)
    CALL_METHODV(B)
    CALL_METHODV(C)
    CALL_METHODV(Z)
    CALL_METHODV(L)
}
